/*
 * Demonstrates how to use a simple web service that tells Chuck Norris jokes.
 * Shows how to parse the JSON format results.
 * 
 * Created by Keith Vertanen
 */

import org.json.*;
import java.io.*;
import java.net.*;

public class ChuckNorris
{
    public static void main(String[] args)
    {

        try
        {
            String            page   = "http://api.icndb.com/jokes/random";
            URL               url    = new URL(page);
            URLConnection     conn   = url.openConnection();
            InputStreamReader stream = new InputStreamReader(conn.getInputStream());
            BufferedReader    reader = new BufferedReader(stream);

            // Read in all the entire HTTP response
            String line     = "";
            String response = "";    
            do
            {
                line = reader.readLine();
                if (line != null)
                    response += line + "\n";
            }
            while (line != null);
            reader.close();

            // Print out the raw JSON data received from Bing
            System.out.println(response);

            // Parse the JSON 
            JSONObject json = new JSONObject(response);

            // Descend to the actual array of web search results
            JSONObject value = json.getJSONObject("value");            
            System.out.printf("%s\n", value.getString("joke"));
        }
        catch (MalformedURLException e) 
        { 
            e.printStackTrace(); 
        }
        catch (IOException e)           
        { 
            e.printStackTrace(); 
        }
    }
}